// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'pascalprecht.translate'])
 

.run(function($ionicPlatform, $translate, $rootScope) {
   
        var chat;
        var lang = window.localStorage.getItem("lang");
        $translate.use(lang);
        $rootScope.refreshLinksEnabled = true;

      $ionicPlatform.ready(function() {
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        if (window.cordova && window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        }
        if (window.StatusBar) {
          // org.apache.cordova.statusbar required
          //StatusBar.styleDefault();
          StatusBar.style(1);
        }



      $rootScope.$on('scope.stored', function (event, data) {
          console.log("scope.stored", data);
      });

  });
  
  
})



    .config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $translateProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
    .state('tab', {
    url: "/tab",
    abstract: true,
    templateUrl: "templates/tabs.html"
  })


  // Each tab has its own nav history stack:
 .state('tab.settings', {
     url: '/settings',
     views: {
         'tab-settings': {
             templateUrl: 'templates/tab-settings.html',
             controller: 'SettingsCtrl'
         }
     }
 })

  .state('tab.dash', {
    url: '/dash',
    views: {
      'tab-dash': {
        templateUrl: 'templates/tab-dash.html',
        controller: 'DashCtrl'
      }
    }
  })

  .state('tab.chats', {
      url: '/chats',
      views: {
        'tab-chats': {
          templateUrl: 'templates/tab-chats.html',
          controller: 'ChatsCtrl'
        }
      }
    })
    .state('tab.chat-detail', {
      url: '/chats/:chatId',
      views: {
        'tab-chats': {
          templateUrl: 'templates/chat-detail.html',
          controller: 'ChatDetailCtrl'
        }
      }
    })

  .state('tab.friends', {
      url: '/friends',
      views: {
        'tab-friends': {
          templateUrl: 'templates/tab-friends.html',
          controller: 'FriendsCtrl'
        }
      }
    })
    .state('tab.friend-detail', {
      url: '/friend/:friendId',
      views: {
        'tab-friends': {
          templateUrl: 'templates/friend-detail.html',
          controller: 'FriendDetailCtrl'
        }
      }
    })

  .state('tab.account', {
    url: '/account',
    views: {
      'tab-account': {
        templateUrl: 'templates/tab-account.html',
        controller: 'AccountCtrl'
      }
    }
  })

  .state('tab.edit-profile', {
      url: '/edit-profile',
      views: {
          'tab-settings': {
              templateUrl: 'templates/edit-profile.html',
              controller: 'EditProfileCtrl'
          }
      }
  });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/dash');
        $ionicConfigProvider.backButton.text('').icon('ion-ios7-arrow-left');

        //otan prostesoume kainouria lang min ksexasoume na allaxoume ta links pou ginete rediect

        $translateProvider.translations('en', {
            DASH_CHECK_IN: 'Check-in...',
            DASH_ENABLE_CHAT: 'Active / Inactive',
            DASH_MESSAGE1: 'Check who\'s around you by clicking....',
            DASH_MESSAGE2: 'Check-in if you want to show your exact position.',
            DASH_MESSAGE3: 'You checked in at....',
            DASH_MESSAGE4: 'Enable chat and check around by clicking....',

            TAB_CHATS_TITLE: 'CheckAround People',
            TAB_CHATS_REFRESH: 'Refresh',
            TAB_CHATS_NOBODY_ONLINE: 'Nobody is around....',

            CHAT_DETAIL_TYPE: 'Type a message....',

            TAB_FRIENDS_TITLE: 'CheckAround Events',
            TAB_FRIENDS_HISTORY: 'Chat history',
            TAB_FRIENDS_NO_EVENT: 'No<br>event around',


            TAB_SETTINGS_TITLE: 'Settings',
            TAB_SETTINGS_PROFILE: 'Profile',
            TAB_SETTINGS_NOTIFICATIONS: 'Notifications',
            TAB_SETTINGS_TERMS_PRIVACY: 'Terms & Privacy',
            FB_LOGIN_LOGOUT: 'Logout',

            EDIT_PROFILE_CHANGE_PHOTO: 'Change your profile pic',
            EDIT_PROFILE_BIRTH: 'Date of Birth',
            EDIT_PROFILE_SEX: 'Sex',
            EDIT_PROFILE_MALE: 'Male',
            EDIT_PROFILE_FEMALE: 'Female',
            EDIT_PROFILE_SAVE: 'Save',
            EDIT_PROFILE_PROFILE: 'Profile',





        });

        $translateProvider.translations('el-GR', {
            DASH_CHECK_IN: 'Check-in...',
            DASH_ENABLE_CHAT: 'Ενεργός / Ανενεργός',
            DASH_MESSAGE1: 'Ανακάλυψε τους γύρω σου πατώντας....',
            DASH_MESSAGE2: 'Κάνε Check in αν θέλεις οι γύρω σου να ξέρουν που ακριβώς βρίσκεσαι.',
            DASH_MESSAGE3: 'Έχεις κάνει Check-in στο/στη....',
            DASH_MESSAGE4: 'Ενεργοποίησε το chat και ανακάλυψε τους γύρω σου πατώντας....',

            TAB_CHATS_TITLE: 'CheckAround People',
            TAB_CHATS_REFRESH: 'Ανανέωση',
            TAB_CHATS_NOBODY_ONLINE: 'Κανείς τριγύρω....',

            CHAT_DETAIL_TYPE: 'Πληκρολόγησε ένα μήνυμα....',

            TAB_FRIENDS_TITLE: 'CheckAround Events',
            TAB_FRIENDS_HISTORY: 'Ιστορικό συνομιλιών',
            TAB_FRIENDS_NO_EVENT: 'Κανένα event<br>τριγύρω',


            TAB_SETTINGS_TITLE: 'Ρυθμίσεις',
            TAB_SETTINGS_PROFILE: 'Profile',
            TAB_SETTINGS_NOTIFICATIONS: 'Ειδοποιήσεις',
            TAB_SETTINGS_TERMS_PRIVACY: 'Όροι Χρήσης & Απόρρητο',
            FB_LOGIN_LOGOUT: 'Έξοδος',

            EDIT_PROFILE_CHANGE_PHOTO: 'Αλλαγή Εικόνας',
            EDIT_PROFILE_BIRTH: 'Ημ/νια Γέννησης',
            EDIT_PROFILE_SEX: 'Φύλο',
            EDIT_PROFILE_MALE: 'Άνδρας',
            EDIT_PROFILE_FEMALE: 'Γυναίκα',
            EDIT_PROFILE_SAVE: 'Αποθήκευση',
            EDIT_PROFILE_PROFILE: 'Profile',



        });


        $translateProvider.preferredLanguage('en');
        //$translateProvider.fallbackLanguage("en");

});


function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

function GetChatHub() {


}


//function registerClientMethods(chatHub) {

//    alert('registerClientMethods');

//    // Calls when user successfully logged in
//    chatHub.client.onConnected = function (id, userName, allUsers, messages) {

//        //setScreen(true);

//        //$('#hdId').val(id);
//        //$('#hdUserName').val(userName);
//        //$('#spanUser').html(userName);

//        //// Add All Users
//        for (i = 0; i < allUsers.length; i++) {
//            alert(allUsers[i].UserName);
//            //alert(chatUsers.length);
//            ////AddUser(chatHub, allUsers[i].ConnectionId, allUsers[i].UserName);
//            //chatUsers.push({
//            //    id: allUsers[i].ConnectionId,
//            //    name: allUsers[i].UserName,
//            //    lastText: allUsers[i].UserName,
//            //    face: 'https://pbs.twimg.com/profile_images/479090794058379264/84TKj_qa.jpeg'
//            //});
//            //alert(chatUsers.length);

//        }
       
//        //// Add Existing Messages
//        ////for (i = 0; i < messages.length; i++) {

//        ////    AddMessage(messages[i].UserName, messages[i].Message);
//        ////}


//    }

//    // On New User Connected
//    chatHub.client.onNewUserConnected = function (id, name) {

//        alert('new user');

//        //AddUser(chatHub, id, name);
//    }


//    // On User Disconnected
//    chatHub.client.onUserDisconnected = function (id, userName) {

//        //$('#' + id).remove();

//        //var ctrId = 'private_' + id;
//        //$('#' + ctrId).remove();


//        //var disc = $('<div class="disconnect">"' + userName + '" logged off.</div>');

//        //$(disc).hide();
//        //$('#divusers').prepend(disc);
//        //$(disc).fadeIn(200).delay(2000).fadeOut(200);

//    }

//    chatHub.client.messageReceived = function (userName, message) {

//        alert(userName);
//        alert(message);
//    }


//    chatHub.client.sendPrivateMessage = function (windowId, fromUserName, message) {

//        var ctrId = 'private_' + windowId;


//        if ($('#' + ctrId).length == 0) {

//            createPrivateChatWindow(chatHub, windowId, ctrId, fromUserName);

//        }

//        $('#' + ctrId).find('#divMessage').append('<div class="message"><span class="userName">' + fromUserName + '</span>: ' + message + '</div>');

//        // set scrollbar
//        var height = $('#' + ctrId).find('#divMessage')[0].scrollHeight;
//        $('#' + ctrId).find('#divMessage').scrollTop(height);

//    }

//}




function registerHubEvents(chat, chats) {






}



		  



