var ids = [];

function getEvents(latitude, longitude, accessToken) {

    fbEventsAround = [];
    fbEventsAround.length = 0;
    fbEventsAroundNow = [];
    fbEventsAroundNow.length = 0;

    //console.log('mitsos-getEvents');

    ids = [];

    if (!latitude || !longitude) {
        //console.log('mitsos-error lat long');
        var error = {
            "message": "Please specify the lat and lng parameters!",
            "code": 1
        };
        //console.error(JSON.stringify(error));
        reject(error);
    } else if (!accessToken) {
        console.log('error accessToken');
        var error = {
            "message": "Please specify an Access Token, either as environment variable or as accessToken parameter!",
            "code": 2
        };
        //console.error(JSON.stringify(error));
        reject(error);
    } else {
        console.log('mitsos-no error');

        var //idLimit = 50, //FB only allows 50 ids per /?ids= call
            currentTimestamp = (new Date().getTime()/1000).toFixed(),
        //venuesCount = 0,
            venuesWithEvents = 0,
            eventsCount = 0,
            version = 2.5,
            query = '',
            distance = 2000,
            placeUrl = "https://graph.facebook.com/v" + version + "/search?" +
                "access_token=" + accessToken +
                "&center=" + latitude + "," + longitude +
                "&debug=all" +
                "&distance=" + distance +
                "&fields=id" +
                "&type=place" +
                "&limit=100" +
                "&pretty=0" +
                "&q=" + query +
                "&suppress_http_code=1" +
                "&type=place";

        //console.log('mitsos-placeUrl='+placeUrl);


        ajaxCall(placeUrl, latitude, longitude, accessToken);

    }
}

function ajaxCall(placeUrl, latitude, longitude, accessToken){

    var eventsTmp = [];
    var goOn = false;

    $('#eventsNoUsersMsg').hide();
    $('#eventsLoader').show();
    eventsCallsProccessing = true;
    $.ajax({
        type: "GET",
        url: placeUrl,
        //data: params,
        contentType: "application/json; charset=utf-8",
        crossDomain: true,
        dataType: "json",
        success: function (data, status, jqXHR) {
            //console.log('mitsos-getplaces call success');
            //console.log('mitsos-data='+JSON.stringify(data));
            //console.log('data-next='+data.paging.next);
            //var next = data.paging.next;
            //console.log('next='+next);


            var tempArray = [],
                data2 = data.data;

            var idLimit = 50, //FB only allows 50 ids per /?ids= call
                currentTimestamp = (new Date().getTime()/1000).toFixed(),
            //venuesCount = 0,
                venuesWithEvents = 0,
                eventsCount = 0,
                version = 2.5;


            //Set venueCount
            var venuesCount = data2.length;

            //Create array of 50 places each
            data2.forEach(function(idObj, index, arr) {
                tempArray.push(idObj.id);
                if (tempArray.length >= idLimit) {
                    ids.push(tempArray);
                    tempArray = [];
                }
            });

            // Push the remaining places
            if (tempArray.length > 0) {
                ids.push(tempArray);
            }

            //return ids;
            //console.log('mitsos-ids='+ids);

            if(typeof data.paging !== "undefined"){
                ajaxCall(data.paging.next, latitude, longitude, accessToken);
            }else{
                goOn = true;
            }


            if(goOn == true){

                var urls = [];

                var fourHoursBeforeTemp = new Date();
                fourHoursBeforeTemp.setHours(fourHoursBeforeTemp.getHours() - 4);
                var fourHoursBefore = (fourHoursBeforeTemp.getTime()/1000).toFixed();

                var tomorrowTemp = new Date();
                tomorrowTemp.setDate(tomorrowTemp.getDate() + 2);//+1 = tommorow
                var tomorrow = (tomorrowTemp.getTime()/1000).toFixed();

                //alert('mitsosssssssssssss='+ids.length);

                //Create a Graph API request array (promisified)
                ids.forEach(function(idArray, index, arr) {
                    //console.log('mitsos-id'+index);
                    var eventsFields = [
                        "id",
                        "type",
                        "name",
                        "cover.fields(id,source)",
                        "picture.type(large)",
                        "description",
                        "start_time",
                        "end_time",
                        "category",
                        "attending_count",
                        "declined_count",
                        "maybe_count",
                        "noreply_count"
                    ];
                    var fields = [
                        "id",
                        "name",
                        "about",
                        "emails",
                        "cover.fields(id,source)",
                        "picture.type(large)",
                        "category",
                        "category_list.fields(name)",
                        "location",
                        "events.fields(" + eventsFields.join(",") + ")"
                    ];

                    var eventsUrl = "https://graph.facebook.com/v" + version + "/" +
                        "?ids=" + idArray.join(",") +
                        "&access_token=" + accessToken +
                        "&fields=" + fields.join(",") +
                        //".since(" + (new Date().getTime()/1000).toFixed() + ")" +
                        ".since(" + fourHoursBefore + ")" +
                        ".until(" + tomorrow + ")";

                    urls.push(eventsUrl);

                    //console.log('mitsos-eventsUrl='+eventsUrl);

                });


                //Handle results
                //alert(urls.length);
                var counter = 0;
                urls.forEach(function(resStr, index, arr) {


                    //console.log('mitsos-resStr='+resStr);


                    $.ajax({
                        type: "GET",
                        url: resStr,
                        //data: params,
                        contentType: "application/json; charset=utf-8",
                        crossDomain: true,
                        dataType: "json",
                        success: function (data, status, jqXHR) {
                            //console.log('mitsos-data='+JSON.stringify(data));
                            var resObj = JSON.parse(JSON.stringify(data));
                            Object.getOwnPropertyNames(resObj).forEach(function(venueId, index, array) {
                                var venue = resObj[venueId];
                                if (venue.events && venue.events.data.length > 0) {
                                    venuesWithEvents++;
                                    venue.events.data.forEach(function(event, index, array) {
                                        var eventResultObj = {};
                                        var categoryList = null;
                                        if (venue.category_list && Array.isArray(venue.category_list)) {
                                            categoryList = [];
                                            venue.category_list.forEach(function (categoryObj) {
                                                if (categoryObj.name) {
                                                    categoryList.push(categoryObj.name);
                                                }
                                            });
                                        }
                                        eventResultObj.id = event.id;
                                        eventResultObj.name = event.name;
                                        eventResultObj.type = event.type;
                                        eventResultObj.coverPicture = (event.cover ? event.cover.source : null);
                                        eventResultObj.profilePicture = (event.picture ? event.picture.data.url : null);
                                        eventResultObj.description = (event.description ? event.description : null);
                                        eventResultObj.distance = (venue.location ? (haversineDistance([venue.location.latitude, venue.location.longitude], [latitude, longitude], false)*1000).toFixed() : null);
                                        eventResultObj.startTime = (event.start_time ? (getFormatedDate(event.start_time)) : null);
                                        eventResultObj.endTime = (event.end_time ? (getFormatedDate(event.end_time)) : null);
                                        eventResultObj.timeFromNow = calculateStarttimeDifference(currentTimestamp, event.start_time);
                                        eventResultObj.timeFromNowCustomText = calculateTimeFromNowCustomText(eventResultObj.timeFromNow);
                                        eventResultObj.category = (event.category ? event.category : null);
                                        eventResultObj.stats = {
                                            attending: event.attending_count,
                                            declined: event.declined_count,
                                            maybe: event.maybe_count,
                                            noreply: event.noreply_count
                                        };
                                        eventResultObj.venue = {};
                                        eventResultObj.venue.id = venueId;
                                        eventResultObj.venue.name = venue.name;
                                        eventResultObj.venue.about = (venue.about ? venue.about : null);
                                        eventResultObj.venue.emails = (venue.emails ? venue.emails : null);
                                        eventResultObj.venue.coverPicture = (venue.cover ? venue.cover.source : null);
                                        eventResultObj.venue.profilePicture = (venue.picture ? venue.picture.data.url : null);
                                        eventResultObj.venue.category = (venue.category ? venue.category : null);
                                        eventResultObj.venue.categoryList = categoryList;
                                        eventResultObj.venue.location = (venue.location ? venue.location : null);
                                        eventsTmp.push(eventResultObj);
                                        if(eventResultObj.timeFromNow.type != 'now') {
                                            fbEventsAround.push(eventResultObj);
                                        }else{
                                            fbEventsAroundNow.push(eventResultObj)
                                        }
                                        fbEventsAround.sort(function(a, b){
                                            return a.distance - b.distance;
                                        });
                                        eventsCount++;
                                    });
                                }
                            });

                            /*if(index == arr.length-1){
                                //alert('1='+fbEventsAroundNow.length);
                                eventsCallsProccessing = false;

                                for(var i=0;i<fbEventsAroundNow.length;i++) {
                                    fbEventsAround.unshift(fbEventsAroundNow[i]);
                                }

                            }*/




                        },
                        error: function (jqXHR, status) {
                            console.log('urls call fail');

                        },
                        complete: function(){
                            counter++;
                            //alert('counter='+counter);
                            //alert('urls.length='+urls.length);
                            if(counter==urls.length){
                                for(var i=0;i<fbEventsAroundNow.length;i++) {
                                    fbEventsAround.unshift(fbEventsAroundNow[i]);
                                }

                                $('#eventsLoader').hide();
                                if(fbEventsAround.length==0){
                                    $('#eventsNoUsersMsg').show();
                                }else{
                                    $('#eventsNoUsersMsg').hide();
                                }
                            }

                        }
                    });

                });
            }

        },
        error: function (jqXHR, status) {
            //console.log('getplaces call fail');

        },
        complete: function(){
            //alert('telos');
        }
    });

}

function calculateStarttimeDifference(currentTime, dataString) {
    //console.log('1='+(new Date(dataString).getTime()));
    //console.log('2='+currentTime*1000)/1000);
    //return (new Date(dataString).getTime()-(currentTime*1000))/1000;

    var a = currentTime,
        b = new Date(dataString).getTime(),
        diff = {};

    diff.milliseconds = a > b ? a % b : b % a;
    diff.seconds = diff.milliseconds / 1000;
    diff.minutes = diff.seconds / 60;
    diff.hours = diff.minutes / 60;
    diff.days = diff.hours / 24;
    diff.weeks = diff.days / 7;

    //return diff;
    var toReturn=Math.floor(Math.round(diff.hours));
    var objectToReturn = {type:"hours", value:toReturn};



    if(toReturn > 400){
        objectToReturn.type='now';
        objectToReturn.value = 0;
    }else if(toReturn == 0){
        toReturn = Math.round(diff.minutes);
        objectToReturn.type='minutes';
        objectToReturn.value = toReturn;
    }

    return objectToReturn;

}

function haversineDistance(coords1, coords2, isMiles) {

    //coordinate is [latitude, longitude]
    function toRad(x) {
        return x * Math.PI / 180;
    }

    var lon1 = coords1[1];
    var lat1 = coords1[0];

    var lon2 = coords2[1];
    var lat2 = coords2[0];

    var R = 6371; // km

    var x1 = lat2 - lat1;
    var dLat = toRad(x1);
    var x2 = lon2 - lon1;
    var dLon = toRad(x2);
    var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) +
        Math.cos(toRad(lat1)) * Math.cos(toRad(lat2)) *
        Math.sin(dLon / 2) * Math.sin(dLon / 2);
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
    var d = R * c;

    if(isMiles) d /= 1.60934;

    return d;

}


function getFormatedDate(inputDate){

    var isIOS = ionic.Platform.isIOS();
    var formatedDateToReturn = '';
    var d = new Date(inputDate);

    if(isIOS){
        var arr = inputDate.split(/[\-\+ :T]/);

        var date = new Date();
        date.setFullYear(arr[0]);
        date.setMonth(arr[1] - 1);
        date.setDate(arr[2]);
        date.setHours(arr[3]);
        date.setMinutes(arr[4]);
        date.setSeconds(arr[5]);
        d=date;
    }

    var curr_date = d.getDate();
    var curr_month = d.getMonth()+1;
    var curr_hours = d.getHours();
    var curr_minutes = d.getMinutes();

    if (curr_minutes < 10) {
        curr_minutes = '0' + curr_minutes;
    }

    formatedDateToReturn = curr_date + "/" + curr_month + " "+curr_hours + ":"+curr_minutes;

    return formatedDateToReturn;

}

function calculateTimeFromNowCustomText(timeFromNowObj){

    var text = '';

    if(timeFromNowObj.type == 'now'){
        text = getMsg('eventsNowIn');
    }else if(timeFromNowObj.type == 'minutes'){
        text = getMsg('eventsAt')+timeFromNowObj.value+getMsg('eventsMinutes');
    }else{
        text = getMsg('eventsAt')+timeFromNowObj.value+getMsg('eventsHours');
    }

    return text;
}
